
var worldgen = function (x,y,bc){
	//Initialize the array
	var world = new Array(x);
	for(i=0;i<world.length;i++){world[i]=new Array(y);}

	//Generate some biomes! 
	var biomes = [ "G", "M", "B", "W", "F", "D", "S" ];
	var centers = new Array(bc);

	for(count=0; count<bc; count++){
		var cx = parseInt(Math.random() * (x-1));
		var cy = parseInt(Math.random() * (y-1));

		//No overwriting
		if (world[cx][cy] != null) {count--; continue;}
		else {
			var nb = biomes[parseInt(Math.random() * (biomes.length -1))];
			world[cx][cy] = nb;
			centers.push([cx, cy, world[cx][cy].toLowerCase()]);
		}
	}
	//OK, that was the centers.
	//Now to fill. 
	
	//Strategy: 
	//Pick a square. 
	//Find the closest center (capital letter).
	//Fill all squares from the square in question to the capital letter with lowercase.
	//continue to next blank square. 
	
	for(i=0;i<x;i++){
		for(j=0;j<y;j++){
			//We only modify empties
			if(world[i][j] != null) continue;
			//Find the closest center - n^2 but we don't care!
			var mindist = x * y * 100;
			centers.forEach(function(c){
				var dist = Math.sqrt( Math.pow((c[0] - i),2) + Math.pow((c[1] - j),2));
				if (dist < mindist){
					mindist = dist;
					world[i][j] = c[2];
				}
			});
		}
	}

	return world;

	//And output it! 
	var newworld = new Array(0);
	for(i=0;i<x;i++){
		var row = "";
		for(j=0;j<y;j++){
			row = row + world[i][j];
			newworld.push([i, j, world[i][j]]);
		}
		console.log(row);
	}

	return newworld;
}

